package school_project.Parsers;

import java.io.File;
import java.io.IOException;
import java.io.NotSerializableException;

/**
 * This is used to find the right parser to parser a save/level file.
 *
 * <p>
 * Mor file format can be added in the future by adding a new class that implement parser and making it recognisable by
 * the CreateParser class
 * </p>
 *
 * @author tonitch
 */
public class FileParserFactory {
    public static FileParser createParser(File file) throws IOException {
        if(BinaryParser.isBinaryFile(file))
            return new BinaryParser();
        else if (JsonParser.isJsonFile(file))
            return new JsonParser();
        else
            throw new NotSerializableException("This file format is not supported");
    }

}
