package school_project.Utils;

public class Bitwise {

    /**
     * Check if the bit at pos is 1 or 0
     * @param b byte to test
     * @param pos position in b to check
     * @return true if the bit at pos is 1 or false if it is 0
     */
    public static boolean IsBitSetAt(byte b, int pos){
        pos = 7 - pos;
        return (b & (1 << pos))!= 0;
    }

    /**
     * Transform a byte (8 bit) to two Nible (4 bit) with a split in the middle
     * Exemple:
     *  in = 01000101 (=69)
     *  out = { 00000100, 00000101 } (={4, 5})
     * @param in the byte to split
     * @return an arrya of 2 byte ret[0] = left part; ret[1] = right part
     */
    public static byte[] ByteToNible(byte in){
        byte[] ret = new byte[2];
        ret[0] = (byte) (in >> 4);
        ret[1] = (byte) (in & 15); // apply the mask '00001111'
        return ret;
    }
}
